apiVersion: {{ deployment_apivers }}
kind: {{ deployment_kind }}
metadata:
  labels:
{% if pki_set | length > 0 %}
    pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    {{ network_policy_deployment_label }}: {{ registry_name }}
  name: {{ registry_name }}
  namespace: {{ namespace }}
spec:
  replicas: {{ registry_replicas }}
  revisionHistoryLimit: {{ deploy_revision_history_limit | default(10) }}
  selector:
{% if deployment_kind != 'DeploymentConfig' %}
    matchLabels:
      name: {{ registry_name }}
  strategy:
{% if do_s3 %}
    type: RollingUpdate
{% else %}
    type: Recreate
{% endif %}
{% else %}
    name: {{ registry_name }}
  strategy:
    resources:
      limits:
        cpu: {{ deploy_pod_cpu_limit }}
        memory: {{ deploy_pod_memory_limit }}
      requests:
        cpu: {{ deploy_pod_cpu_request }}
        memory: {{ deploy_pod_memory_request }}
{% if do_s3 %}
    type: Rolling
{% else %}
    type: Recreate
{% endif %}
{% endif %}
  template:
    metadata:
      labels:
        name: {{ registry_name }}
{% if pki_set | length > 0 %}
        pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    spec:
{% if do_affinities %}
      affinity:
        podAntiAffinity:
{% if scheduling_affinity_required %}
          requiredDuringSchedulingIgnoredDuringExecution:
          - labelSelector:
              matchExpressions:
              - key: name
                operator: In
                values: [ {{ registry_name }} ]
            topologyKey: {{ k8s_affinity_zone_label }}
{% else %}
          preferredDuringSchedulingIgnoredDuringExecution:
          - podAffinityTerm:
              labelSelector:
                matchExpressions:
                - key: name
                  operator: In
                  values: [ {{ registry_name }} ]
              topologyKey: {{ k8s_affinity_zone_label }}
            weight: 42
{% endif %}
{% endif %}
      automountServiceAccountToken: false
      containers:
      - env:
        - name: REGISTRY_HTTP_SECRET
          valueFrom:
            secretKeyRef:
              key: http-secret
              name: {{ registry_name }}
{% if do_s3 %}
{% if registry_s3_flavor == 'minio' %}
        - name: REGISTRY_STORAGE_S3_ACCESSKEY
          valueFrom:
            secretKeyRef:
              key: access-key
              name: {{ minio_name }}-registry
        - name: REGISTRY_STORAGE_S3_BUCKET
          valueFrom:
            secretKeyRef:
              key: bucket
              name: {{ minio_name }}-registry
        - name: REGISTRY_STORAGE_S3_REGION
          valueFrom:
            secretKeyRef:
              key: region
              name: {{ minio_name }}-registry
        - name: REGISTRY_STORAGE_S3_SECRETKEY
          valueFrom:
            secretKeyRef:
              key: secret-key
              name: {{ minio_name }}-registry
{% elif registry_s3_flavor in [ 'ceph', 'rados', 'radosgw' ] %}
        - name: REGISTRY_STORAGE_S3_ACCESSKEY
          valueFrom:
            secretKeyRef:
              key: access-key
              name: {{ rgw_name }}-registry
        - name: REGISTRY_STORAGE_S3_BUCKET
          valueFrom:
            secretKeyRef:
              key: bucket
              name: {{ rgw_name }}-registry
        - name: REGISTRY_STORAGE_S3_SECRETKEY
          valueFrom:
            secretKeyRef:
              key: secret-key
              name: {{ rgw_name }}-registry
{% endif %}
{% endif %}
        - name: TZ
          value: {{ timezone }}
{% if do_triggers == False or (opsimages | json_query("[?name=='registry'].short"))[0] == False %}
        image: {{ (opsimages | json_query("[?name=='registry'].image"))[0] }}
{% endif %}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
          tcpSocket:
            port: 5000
        name: registry
        ports:
        - containerPort: 5000
        readinessProbe:
          tcpSocket:
            port: 5000
        resources:
          limits:
            cpu: {{ registry_cpu_limit }}
            memory: {{ registry_memory_limit }}
          requests:
            cpu: {{ registry_cpu_request }}
            memory: {{ registry_memory_request }}
        securityContext:
          allowPrivilegeEscalation: false
        volumeMounts:
        - mountPath: /etc/docker/registry
          name: conf
        - mountPath: /var/lib/registry
          name: data
        - mountPath: /certs
          name: certs
{% if do_exporters and not do_s3 %}
      - args:
        - /var/lib/registry/docker/registry/v2
{% if do_triggers == False or (opsimages | json_query("[?name=='registryexporter'].short"))[0] == False %}
        image: {{ (opsimages | json_query("[?name=='registryexporter'].image"))[0] }}
{% endif %}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
          httpGet:
            path: /metrics
            port: 8080
          initialDelaySeconds: 30
          periodSeconds: 20
          timeoutSeconds: 3
        name: exporter
        ports:
        - containerPort: 8080
        resources:
          limits:
            cpu: {{ exporter_cpu_limit }}
            memory: {{ exporter_memory_limit }}
          requests:
            cpu: {{ exporter_cpu_request }}
            memory: {{ exporter_memory_request }}
        securityContext:
          allowPrivilegeEscalation: false
        volumeMounts:
        - mountPath: /var/lib/registry
          name: data
{% endif %}
{% if k8s_resource_nodes_selectors | length > 0 %}
      nodeSelector:
{% for sel in k8s_resource_nodes_selectors %}
        {{ sel.split('=')[0] }}: "{{ sel.split('=')[1] if (sel.split('=') | length > 1) else '' }}"
{% endfor %}
{% endif %}
{% if k8s_flavor == 'kubernetes' or (k8s_flavor == 'openshift' and ocp_major in [ 4, '4' ]) %}
      priorityClassName: opsperator-database
{% endif %}
{% if k8s_flavor == 'kubernetes' or (rwx_storage | default(False) and rwx_needs_fsgroup | default(False)) or (rwx_storage is not defined and rwo_needs_fsgroup | default(False)) %}
      securityContext:
{% if rwx_storage | default(False) and rwx_needs_fsgroup | default(False) %}
        fsGroup: {{ rwx_needs_fsgroup }}
{% elif rwx_storage is not defined and rwo_needs_fsgroup | default(False) %}
        fsGroup: {{ rwo_needs_fsgroup }}
{% endif %}
{% if k8s_flavor == 'kubernetes' %}
        runAsUser: {{ k8s_unprivileged_userid }}
{% endif %}
{% else %}
      securityContext: {}
{% endif %}
{% if do_topology_spread_constraints | default(False) %}
      topologySpreadConstraints:
      - labelSelector:
          matchLabels:
            name: {{ registry_name }}
        maxSkew: {{ topology_spread_max_skew | default(1) }}
        topologyKey: {{ k8s_affinity_zone_label }}
{% if scheduling_affinity_required %}
        whenUnsatisfiable: DoNotSchedule
{% else %}
        whenUnsatisfiable: ScheduleAnyway
{% endif %}
{% endif %}
      volumes:
      - configMap:
          defaultMode: 420
          name: {{ registry_name }}
        name: conf
{% if registry_do_tls %}
      - name: certs
        secret:
          secretName: {{ registry_name }}-cert
{% else %}
      - emptyDir: {}
        name: certs
{% endif %}
{% if do_s3 %}
      - emptyDir: {}
        name: data
{% else %}
      - name: data
        persistentVolumeClaim:
          claimName: {{ registry_name }}
{% endif %}
{% if do_triggers %}
  triggers:
{% if (opsimages | json_query("[?name=='registry'].short"))[0] %}
  - type: ImageChange
    imageChangeParams:
      automatic: true
      containerNames:
      - registry
      from:
        kind: ImageStreamTag
        name: {{ (opsimages | json_query("[?name=='registry'].short"))[0] }}
        namespace: {{ buildns }}
{% endif %}
{% if do_exporters and (opsimages | json_query("[?name=='registryexporter'].short"))[0] and not do_s3 %}
  - type: ImageChange
    imageChangeParams:
      automatic: true
      containerNames:
      - exporter
      from:
        kind: ImageStreamTag
        name: {{ (opsimages | json_query("[?name=='registryexporter'].short"))[0] }}
        namespace: {{ buildns }}
{% endif %}
  - type: ConfigChange
{% endif %}
